// graph1.cpp
#include <stdlib.h>
#include <time.h>
#pragma hdrstop
#include "graph1.h"

// This func fades the screen either to black, or to white.
void Fade(TDC &dc, TPalette &pal, long delay, int dir){

// This is very slow under win95 and doesn't have a very nice effect
	 PALETTEENTRY wpal[256];
	 pal.GetPaletteEntries(0, 256, wpal);
	 int x,y;
	 long c;
	 if (dir == FADE_TO_BLACK)
		  for(x = 0; x < 256; x++){
				for(y = 10; y < 246; y++){
				  PALETTEENTRY *p = &wpal[y];
				  if (p->peRed) p->peRed--;
				  if (p->peGreen) p->peGreen--;
				  if (p->peBlue) p->peBlue--;
				}
				for (c = 0;c < delay; c++);
				pal.SetPaletteEntries(0, 256, wpal);
				dc.RealizePalette();
		  }
	 else
		  for(x = 0; x < 256; x++){
				for(y = 10; y < 246; y++){
				  PALETTEENTRY *p = &wpal[y];
				  if (p->peRed < 255) p->peRed++;
				  if (p->peGreen < 255) p->peGreen++;
				  if (p->peBlue < 255) p->peBlue++;
				}
				for (c = 0;c < delay; c++);
				pal.SetPaletteEntries(0, 256, wpal);
				dc.RealizePalette();
		  }
}



// This func melts the screen.
void Melt(TDC &dc, TRect cRect, TColor color, long delay){

	 long d; // use in delay loop;

	 TPen pen(color);
	 TBrush brush(color);
	 randomize();
	 cRect.Normalize();

	 if (cRect.IsNull())
		 return;

	 dc.SelectObject(pen);
	 dc.SelectObject(brush);

	 int numbWorms = cRect.Width() / WORMWIDTH + 2; // One extra worm for initializing
	 Worm *worms = new Worm[numbWorms];
	 Worm *w;

	 // Set up a number that will allow us to clear the whole screen
	 int min = (cRect.Height() / WORMHEIGHT + 1) + 50;

	 // initialize worms.  Start each worm at a different location
	 int c;
	 worms[0].p.y = cRect.top - 10; // set up a fake worm
	 w = &worms[1]; // Start at the second worm
	 for (c = 1; c < numbWorms; c++){
		  // base the next start pos on the previous worm.  Then, only allow
		  // the pos to be less then the top of the window.
		  while((w->p.y = worms[c-1].p.y + random(41) - 20) > cRect.top ||
					w->p.y < (cRect.top - 160));//  0 thru -160 from top of client area
		  w->p.x = (c * WORMWIDTH);
		  w++;
	 }

	 // start the melt loop.  Move all the worms down at a constant velocity

	 while(min--){
		 w = &worms[1]; // start at the second worm
		 for (c = 1; c < numbWorms; c++){ // just keep melting every worm
			  dc.Rectangle(w->p.x,w->p.y,
								w->p.x + WORMWIDTH, w->p.y + WORMHEIGHT);
			  w->p.y += WORMHEIGHT;
			  w++; // point to next worm;
		 }
		 for (d = 0; d < delay; d++);
	 }

	 delete [] worms;

	 dc.RestorePen();
	 dc.RestoreBrush();
}
